unit Unit23;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,system.TypInfo;

type
  TForm23 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form23: TForm23;

implementation

{$R *.dfm}

uses
  system.math;

function SetToString(Info: PTypeInfo; const Value): string;
var
  I: Integer;
  Data: PTypeData;        // set's type data
  EnumInfo: PTypeInfo;	 // set's base type info
  EnumData: PTypeData;    // set's base type data
begin
  if Info.Kind <> tkSet then
    Result := ''
  else
  begin
    Data := GetTypeData(Info);
    EnumInfo := Data^.CompType^;
    EnumData := GetTypeData(EnumInfo);

    Assert(EnumInfo.Kind in [tkEnumeration,tkInteger]);

    Result := '[';
    for I := EnumData.MinValue to EnumData.MaxValue do
      if I in TIntegerSet(Value) then
      begin
        // The element is in the set, so add its name to the string.
        if Length(Result) > 1 then
          Result := Result + ',';  // Separate items with commas.
        Result := Result + GetEnumName(EnumInfo, I);
      end;
    Result := Result + ']';
  end;
end;

procedure TForm23.Button1Click(Sender: TObject);
var
   v1,v2,v3:variant;
begin
     v1:=0;
     v2:=0;
     v3:=v1/v2;
end;

procedure TForm23.Button2Click(Sender: TObject);
var
   v1,v2:integer;

begin
     v1:=0;
     v2:=0;
     showmessage(Floattostr(v1/v2));
end;

procedure TForm23.Button3Click(Sender: TObject);
var
   v1,v2,v3:variant;
begin
     v1:=1;
     v2:=0;
     v3:=v1/v2;
end;


procedure TForm23.Button4Click(Sender: TObject);
var
   v1,v2:integer;

begin
     v1:=1;
     v2:=0;
     showmessage(Floattostr(v1/v2));
end;



procedure TForm23.Button5Click(Sender: TObject);
begin
    inputbox('GetExceptionMask','',   SetToString(TypeInfo(TArithmeticExceptionMask),GetExceptionMask));
end;

end.
